// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.18.1
// source: backup/backup_service.proto

package backup

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// BackupClient is the client API for Backup service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type BackupClient interface {
	// выгрузка данных с типом BackupBlob.Type, если он равен unknown то выгружаются все
	Download(ctx context.Context, in *BackupBlob, opts ...grpc.CallOption) (Backup_DownloadClient, error)
	Upload(ctx context.Context, opts ...grpc.CallOption) (Backup_UploadClient, error)
}

type backupClient struct {
	cc grpc.ClientConnInterface
}

func NewBackupClient(cc grpc.ClientConnInterface) BackupClient {
	return &backupClient{cc}
}

func (c *backupClient) Download(ctx context.Context, in *BackupBlob, opts ...grpc.CallOption) (Backup_DownloadClient, error) {
	stream, err := c.cc.NewStream(ctx, &Backup_ServiceDesc.Streams[0], "/arrays.Backup/Download", opts...)
	if err != nil {
		return nil, err
	}
	x := &backupDownloadClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Backup_DownloadClient interface {
	Recv() (*BackupBlob, error)
	grpc.ClientStream
}

type backupDownloadClient struct {
	grpc.ClientStream
}

func (x *backupDownloadClient) Recv() (*BackupBlob, error) {
	m := new(BackupBlob)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *backupClient) Upload(ctx context.Context, opts ...grpc.CallOption) (Backup_UploadClient, error) {
	stream, err := c.cc.NewStream(ctx, &Backup_ServiceDesc.Streams[1], "/arrays.Backup/Upload", opts...)
	if err != nil {
		return nil, err
	}
	x := &backupUploadClient{stream}
	return x, nil
}

type Backup_UploadClient interface {
	Send(*BackupBlob) error
	CloseAndRecv() (*BackupBlob, error)
	grpc.ClientStream
}

type backupUploadClient struct {
	grpc.ClientStream
}

func (x *backupUploadClient) Send(m *BackupBlob) error {
	return x.ClientStream.SendMsg(m)
}

func (x *backupUploadClient) CloseAndRecv() (*BackupBlob, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(BackupBlob)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// BackupServer is the server API for Backup service.
// All implementations should embed UnimplementedBackupServer
// for forward compatibility
type BackupServer interface {
	// выгрузка данных с типом BackupBlob.Type, если он равен unknown то выгружаются все
	Download(*BackupBlob, Backup_DownloadServer) error
	Upload(Backup_UploadServer) error
}

// UnimplementedBackupServer should be embedded to have forward compatible implementations.
type UnimplementedBackupServer struct {
}

func (UnimplementedBackupServer) Download(*BackupBlob, Backup_DownloadServer) error {
	return status.Errorf(codes.Unimplemented, "method Download not implemented")
}
func (UnimplementedBackupServer) Upload(Backup_UploadServer) error {
	return status.Errorf(codes.Unimplemented, "method Upload not implemented")
}

// UnsafeBackupServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to BackupServer will
// result in compilation errors.
type UnsafeBackupServer interface {
	mustEmbedUnimplementedBackupServer()
}

func RegisterBackupServer(s grpc.ServiceRegistrar, srv BackupServer) {
	s.RegisterService(&Backup_ServiceDesc, srv)
}

func _Backup_Download_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(BackupBlob)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(BackupServer).Download(m, &backupDownloadServer{stream})
}

type Backup_DownloadServer interface {
	Send(*BackupBlob) error
	grpc.ServerStream
}

type backupDownloadServer struct {
	grpc.ServerStream
}

func (x *backupDownloadServer) Send(m *BackupBlob) error {
	return x.ServerStream.SendMsg(m)
}

func _Backup_Upload_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(BackupServer).Upload(&backupUploadServer{stream})
}

type Backup_UploadServer interface {
	SendAndClose(*BackupBlob) error
	Recv() (*BackupBlob, error)
	grpc.ServerStream
}

type backupUploadServer struct {
	grpc.ServerStream
}

func (x *backupUploadServer) SendAndClose(m *BackupBlob) error {
	return x.ServerStream.SendMsg(m)
}

func (x *backupUploadServer) Recv() (*BackupBlob, error) {
	m := new(BackupBlob)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Backup_ServiceDesc is the grpc.ServiceDesc for Backup service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Backup_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "arrays.Backup",
	HandlerType: (*BackupServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Download",
			Handler:       _Backup_Download_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "Upload",
			Handler:       _Backup_Upload_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "backup/backup_service.proto",
}
